<?php

// echo 'Version php courante : ' . phpinfo();

// function latlong($addr){
   // $a = urlencode($addr);
   // $geocodeURL = "http://maps.googleapis.com/maps/api/geocode/json?address=$a&sensor=false";
   // $ch = curl_init($geocodeURL);
   // curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
   // $result = curl_exec($ch);
   // $httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
   // curl_close($ch);
   // if ($httpCode == 200) {
      // $geocode = json_decode($result);
      // $lat = $geocode->results[0]->geometry->location->lat;
      // $lng = $geocode->results[0]->geometry->location->lng; 
      // $formatted_address = $geocode->results[0]->formatted_address;
      // $geo_status = $geocode->status;
      // $location_type = $geocode->results[0]->geometry->location_type;
   // } else {
     // $geo_status = "HTTP_FAIL_$httpCode";
   // }
   // return $addr;
   // }
define("mooGEOCODING_SERVER", "maps.google.com");
define("mooGEOCODING_SERVER_PATH", "/maps/api/geocode/json");
// !!! no config below this line.................................................  

//sanitization and encoding functions (this could be better implemented)
function moo_sanitize_str_paranoid_mode($data){
	$data = preg_replace("/[^a-zA-Z0-9 ,]/", "", $data);
return $data;
}
function moo_req_encode ($data) {
	$data = urlencode( stripslashes($data) );
return $data;
}

// socketopen based function, if needed could be replaced with CURL etc.
function moo_socket_get($host, $path, $req='', $port = 80) {
	$http_request  = "GET $path$req HTTP/1.0\r\n";
	$http_request .= "Host: $host\r\n";
	//$http_request .= "Content-Type: application/x-www-form-urlencoded;\r\n";
	$http_request .= "Content-Type: text/html\r\n";
	//$http_request .= "Content-Length: " . strlen($req) . "\r\n";
	$http_request .= "User-Agent: GGeocoderParserLib(PHPlib-V1)\r\n";
	$http_request .= "Connection: Close\r\n";
	$http_request .= "\r\n";
	//$http_request .= $req;
	$response = '';
	if( false == ( $fs = @fsockopen($host, $port, $errno, $errstr, 10) ) ) {
		die ('Could not open socket in order to connect');
	}
	fwrite($fs, $http_request);
	while ( !feof($fs) ){
		$response .= fgets($fs, 1500);
	}
	fclose($fs);
return $response;
}

// get G geocoder json from G geocoder service
function get_ggeocoder_json($address='',$latlng='',$language='en',$sensor ='false') {
	$ggeo = new simple_ggeocoder_json_parser($address,$latlng,$language,$sensor);
    return $ggeo;
}

class simple_ggeocoder_json_parser {
    public $status = 'MOOGEOCODING:NONE';
	public $address = '';
	public $header = '';
    public $json = '';
	public $plaintext = '';
    public $results = array();
    public $obj = null;

    function __construct($address='',$latlng='',$language='en',$sensor ='false') {
    	$this->address = $address;
		$this->language = $language;
		$this->status = 'MOOGEOCODING:INIT';
		$this->load($address,$latlng,$language,$sensor);
		$this->parse_default();
    }
	function load($address,$latlng,$language,$sensor){
		//some sanitization and encoding and empty string detection again
		$address=moo_req_encode(moo_sanitize_str_paranoid_mode($address));
		$latlng=moo_req_encode(moo_sanitize_str_paranoid_mode($latlng));
		if ( empty($address) && empty($latlng) ) {
			$this->status = "MOOGEOCODING:UNSUBMITTED,WRONG_ADDRESS"; //something illegal in the string
			return FALSE;
		}
		$server=mooGEOCODING_SERVER;
		$server_path=mooGEOCODING_SERVER_PATH;
		$params='?address='.$address.'&language='.$language.'&sensor='.$sensor;
		
		$server_response = moo_socket_get($server,$server_path,$params);
		$pos = strpos($server_response, 'OK');
		if ($pos === false) {
			$this->status = "MOOGEOCODING:FAILED";
			return FALSE;
		}
		$this->plaintext = $server_response;
		$pieces = explode("\r\n\r\n", $server_response); // split header/content
		$this->header=$pieces[0];
		$this->json=$pieces[1];
		$this->obj = json_decode($this->json);
		//echo '<pre>'; print_r($obj); echo '<pre>';
		$this->status = "MOOGEOCODING:PASSED";
		return TRUE;
	}
	function parse_default(){
		$this->results['status']=$this->obj->status;
		if($this->results['status']!=='OK'){
			return FALSE;
		}
		$this->results['count']=count($this->obj->results);
		if($this->results['count']<1){
			return FALSE;
		} 
		//get some values only from first result, add whatever you may need :)
		$this->results['formatted_address']=$this->obj->results[0]->formatted_address;
		$this->results['latitude']=$this->obj->results[0]->geometry->location->lat;
		$this->results['longitude']=$this->obj->results[0]->geometry->location->lng;
		return TRUE;
	}
	function find_address_components($type) {
		if($this->results['status']!=='OK'){
			return FALSE;
		}
		foreach($this->obj->results[0]->address_components as $k=>$found){
			//echo '<pre>';print_r($found);echo '</pre>';
			if(in_array($type, $found->types)){
				return $found;
			} 
		}
		return FALSE;
	}

    function __destruct() {
        $this->clear();
    }
    // clean up memory
    function clear() {
        $this->status = null;
        $this->address = null;
        $this->header = null;
        $this->json = null;
		$this->plaintext = null;
		$this->results = null;
		$this->obj = null;
    }
}	

function test($url){
	$a = urlencode($url);
	// include('GGeocoderParserLib.v1.php');

// create an object to hold the Google Geocoder response 
	$ggeo = get_ggeocoder_json($a,'','fr');

// some predefined fields parser is looking for
// echo $ggeo->results['formatted_address'].'<br />';
	$lat = $ggeo->results['latitude'];
	$lng = $ggeo->results['longitude'];

// looking for a fields from address_components
		$x=$ggeo->find_address_components('country');
// echo '<pre>';print_r($x);echo '</pre>';

// see the object structure 
// echo '<pre>';print_r($ggeo);echo '</pre>';
		return $lat."-".$lng."-".$x;
   }
?>